diff -uwrN sourceold/scripts/DBIKScripts.cpp source/scripts/DBIKScripts.cpp
--- sourceold/scripts/DBIKScripts.cpp	2017-11-23 05:41:45.146800000 +1000
+++ source/scripts/DBIKScripts.cpp	2018-11-11 08:30:08.519600000 +1000
@@ -10,6 +10,7 @@
 #include "PurchaseSettingsDefClass.h"
 #include "GameObjManager.h"
 #include "DB_General.h"
+#include "PurchaseSettingsDefClass.h"
 #ifdef DRAGONADE
 #include "engine_da.h"
 #endif // DRAGONADE
@@ -1015,7 +1016,7 @@
 		if (Get_Float_Parameter("Cost") && Commands->Get_Money(obj) < Get_Float_Parameter("Cost"))
 		{
 			char costMessage[220];
-			sprintf(costMessage,"You need $%d to place this.",Get_Float_Parameter("Cost"));
+			sprintf(costMessage,"You need $%i to place this.",(int)Get_Float_Parameter("Cost"));
 			Send_Message_Player(obj,255,255,255,costMessage);
 			return;
 		}
@@ -1779,3 +1780,59 @@
 ScriptRegistrant<DB_Damage_Vehicle_Occupants_Area_Timer> DB_Damage_Vehicle_Occupants_Area_Timer_Registrant("DB_Damage_Vehicle_Occupants_Area_Timer","Occupants_Damage_Amount=1000:float,Occupants_Damage_Warhead=warhead:string,Damage_Distance=1000:float,ShooterID=0:int");
 ScriptRegistrant<DB_Damage_Vehicle_Occupants_Area_Killed> DB_Damage_Vehicle_Occupants_Area_Killed_Registrant("DB_Damage_Vehicle_Occupants_Area_Killed","Area_Damaging_Explosion=explosion:string,Occupants_Damage_Warhead=warhead:string,Occupants_Damage_Amount=1000:float,Damage_Distance=1000:float");
 
+void DB_Set_PT_Slot::Created(GameObject *obj)
+{
+	Commands->Start_Timer(obj,this,0.0f,12321);
+	int Type=Get_Int_Parameter("Type");
+		int Team=Get_Int_Parameter("Team");
+		int Slot=Get_Int_Parameter("Slot");
+		int Alt=Get_Int_Parameter("Alt");
+		StringClass Preset=Get_Parameter("Preset");
+		if(stristr(Preset,"mirage"))
+		{
+			Team=0;
+			Type=1;
+			Slot=9;
+			Alt=0;
+		}
+		PurchaseSettingsDefClass *PT = PurchaseSettingsDefClass::Find_Definition((PurchaseSettingsDefClass::TYPE)Type,(PurchaseSettingsDefClass::TEAM)Team);
+		if(PT)
+		{
+			int PresetID = Get_Definition_ID(Preset);
+			if(PresetID)
+			{
+				if(Alt==0 || Alt==1 || Alt==2)
+				{
+					PT->Set_Alt_Definition(Slot,Alt,PresetID);
+				}
+				else
+				{
+					PT->Set_Definition(Slot,PresetID);
+				}
+			}
+			else
+			{
+				if(Alt==0 || Alt==1 || Alt==2)
+				{
+					PT->Set_Alt_Definition(Slot,Alt,0);
+				}
+				else
+				{
+					PT->Set_Definition(Slot,0);
+				}
+			}
+		}
+
+}
+
+void DB_Set_PT_Slot::Timer_Expired(GameObject *obj,int number)
+{
+#ifdef DRAGONADE
+	if(number==12321)
+	{
+		Console_Input("reload");
+	}
+#endif // DRAGONADE
+}
+
+ScriptRegistrant<DB_Set_PT_Slot> DB_Set_PT_Slot_Registrant("DB_Set_PT_Slot","Team=0:int,Type=0:int,Slot=0:int,Alt=-1:int,Preset=CnC_Nod_Light_Tank:String");
\ No newline at end of file
diff -uwrN sourceold/scripts/DBIKScripts.h source/scripts/DBIKScripts.h
--- sourceold/scripts/DBIKScripts.h	2017-11-23 05:41:45.147800000 +1000
+++ source/scripts/DBIKScripts.h	2018-11-11 08:30:08.520600000 +1000
@@ -260,3 +260,8 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj, int number);
 };
\ No newline at end of file
+
+class DB_Set_PT_Slot : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/DBScripts.cpp source/scripts/DBScripts.cpp
--- sourceold/scripts/DBScripts.cpp	2017-11-23 05:41:45.148800000 +1000
+++ source/scripts/DBScripts.cpp	2018-11-11 08:30:08.521600000 +1000
@@ -564,26 +564,36 @@
 
 class DB_capturable_Helipad_Terminal : public ScriptImpClass {
 	bool Do_Poke_Stuff;
+	ReferencerClass building;
 void  DB_capturable_Helipad_Terminal::Created(GameObject *obj)
 {
 	Do_Poke_Stuff = true; 
 	Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	Commands->Set_Animation_Frame(obj,Get_Model(obj),0);
+	Commands->Start_Timer(obj,this,0.5f,1);
+	building = Commands->Find_Object(Get_Int_Parameter("BuildingID"));
 }
 void  DB_capturable_Helipad_Terminal::Poked(GameObject *obj,GameObject *poker)
 {
 	if (Do_Poke_Stuff)
 	{
 		Do_Poke_Stuff = false; Commands->Start_Timer(obj,this,5.0f,12345);
-		if (Get_Object_Type(Commands->Find_Object(Get_Int_Parameter("BuildingID")))==Get_Object_Type(poker))
+		if (Get_Object_Type(building)==Get_Object_Type(poker))
 		{
 			const char *preset;
-			int cost;
+			float cost;
 			int spawnlocation;
 			Vector3 location;
-			cost=Get_Int_Parameter("Cost");
+			bool powered=true;
+			cost=Get_Float_Parameter("Cost");
 			preset = Get_Parameter("Preset");
 			spawnlocation = Get_Int_Parameter("SpawnLocation");
 			location = Commands->Get_Position(Commands->Find_Object(spawnlocation));
+			if(!Is_Base_Powered(Get_Object_Type(poker)))
+			{
+				powered=false;
+				cost=cost*1.5f;
+			}
 			if (cost <= Commands->Get_Money(poker))
 			{
 				cost = -cost;
@@ -595,20 +605,24 @@
 				{
 					Set_Object_Type(Purchase,Get_Object_Type(poker));
 					Purchase->As_VehicleGameObj()->Lock_Vehicle(poker,45.0f);
-					//if(!Purchase->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(Purchase->As_PhysicalGameObj()->Get_Transform()))
-						//Fix_Stuck_Object(Purchase->As_VehicleGameObj(),15);
 				}
-				Send_Message_Player(poker,255,255,255,"Purchase request granted!");
+				Send_Message_Team(Get_Object_Type(poker),160,160,255,StringClass::getFormattedString("Building: %s - %s",Get_Translated_Definition_Name(preset),Get_Player_Name(poker)));
+				Send_Message_Player(poker,178,178,178,"Purchase request granted!");
+				Stop_Timer2(obj,this,1);
+				DB_capturable_Helipad_Terminal::Timer_Expired(obj, 1);
 			}
 			else
 			{
 				PlayInsufficientFunds(poker);
+				if(!powered)
+					Send_Message_Player(poker,255,255,255,"Access Denied! Insufficient Funds! (Power Down - Cost x 1.5)");
+				else
 				Send_Message_Player(poker,255,255,255,"Access Denied! Insufficient Funds!");
 			}
 		}
 		else
 		{
-			const char *Building = Get_Translated_Preset_Name(Commands->Find_Object(Get_Int_Parameter("BuildingID")));
+			const char *Building = Get_Translated_Preset_Name(building);
 			Send_Message_Player(poker,255,255,255,StringClass::getFormattedString("Sorry, the %s is not captured. Purchase denied.",Building));
 
 		}
@@ -617,11 +631,74 @@
 }
 void  DB_capturable_Helipad_Terminal::Timer_Expired(GameObject *obj, int number)
 {
-	if (number == 12345)
+	if(number == 1)
+	{
+		int team = Get_Object_Type(building);
+		int frame = 0;
+		if(team == 1)
+		{
+			if(Do_Poke_Stuff)
+			{
+				if(Is_Base_Powered(1))
+					frame=7;
+				else
+					frame=5;
+			}
+			else
+			{
+				if(Is_Base_Powered(1))
+					frame=8;
+				else
+					frame=6;
+			}
+			if(Get_Object_Type(obj) != -2)
+			{
+				Set_Object_Type(obj,1);
+			}
+		}
+		else if (team == 0)
+		{
+			if(Do_Poke_Stuff)
+			{
+				if(Is_Base_Powered(0))
+					frame=3;
+				else
+					frame=1;
+			}
+			else
+			{
+				if(Is_Base_Powered(0))
+					frame=4;
+				else
+					frame=2;
+			}
+			if(Get_Object_Type(obj) != 0)
+			{
+				Set_Object_Type(obj,0);
+			}
+		}
+		else
+		{
+			frame=0;
+			if(Get_Object_Type(obj) != -2)
+			{
+				Set_Object_Type(obj,-2);
+			}
+		}
+		if(Get_Animation_Frame(obj) != frame)
+		{
+			Commands->Set_Animation_Frame(obj,Get_Model(obj),frame);
+		}
+		Commands->Start_Timer(obj,this,0.5f,1);
+	}
+
+	else if (number == 12345)
 	{
 		Do_Poke_Stuff = true;
 		Commands->Enable_HUD_Pokable_Indicator(obj, true);
 	}
+
+
 }
 };
 
diff -uwrN sourceold/scripts/MoveablePhysDefClass.h source/scripts/MoveablePhysDefClass.h
--- sourceold/scripts/MoveablePhysDefClass.h	2016-10-31 07:17:12.366013500 +1000
+++ source/scripts/MoveablePhysDefClass.h	2018-11-11 08:30:08.522600000 +1000
@@ -25,8 +25,10 @@
 	virtual bool								Load(ChunkLoadClass &cload);
 	float											Get_Mass(void)					{ return Mass; }
 	float											Get_Grav_Scale(void)			{ return GravScale; }
+	float											Get_Elasticity(void) { return Elasticity; }
 	void											Set_Mass(float new_mass)	{ Mass = new_mass; }
 	void											Set_Grav_Scale(float new_g){ GravScale = new_g; }
+	void											Set_Elasticity(float new_e) { Elasticity = new_e; }
 #ifdef DDBEDIT
 	virtual void                        Dump (FileClass &file);
 #endif
diff -uwrN sourceold/scripts/PhysicsSceneClass.h source/scripts/PhysicsSceneClass.h
--- sourceold/scripts/PhysicsSceneClass.h	2016-10-31 07:17:12.379013500 +1000
+++ source/scripts/PhysicsSceneClass.h	2018-11-11 08:30:08.523600000 +1000
@@ -250,6 +250,7 @@
 	void Post_Load_Level_Dynamic_Data(void);
 	void Set_Polygon_Budgets(int static_count,int dynamic_count);
 	void Get_Polygon_Budgets(int * static_count,int * dynamic_count);
+	void Refresh_Polygon_Budgets();
 	void Set_Update_Only_Visible_Objects(bool b) { UpdateOnlyVisibleObjects=b; }
 	bool Get_Update_Only_Visible_Objects() { return UpdateOnlyVisibleObjects; }
 	virtual void Add_Render_Object(RenderObjClass * obj);
@@ -390,6 +391,8 @@
 	static bool AllowCollisionFlags[NUM_COLLISION_FLAGS];
 	int DynamicPolyBudget;
 	int StaticPolyBudget;
+	float mapStaticPolyBudget;
+	float mapDynamicPolyBudget;
 	RefMultiListClass<PhysClass> ObjList;
 	RefMultiListClass<PhysClass> StaticObjList;
 	RefMultiListClass<PhysClass> StaticLightList;
diff -uwrN sourceold/scripts/PurchaseSettingsDefClass.h source/scripts/PurchaseSettingsDefClass.h
--- sourceold/scripts/PurchaseSettingsDefClass.h	2016-10-31 07:17:12.386013500 +1000
+++ source/scripts/PurchaseSettingsDefClass.h	2018-11-11 08:30:08.524600000 +1000
@@ -184,6 +184,15 @@
 		PageBusy = b;
 		Set_Object_Dirty_Bit(BIT_OCCASIONAL,true);
 	}
+	void Set_Definition(int index,int preset) {
+		presetids[index] = preset;
+	}
+	void Set_Alt_Definition(int index,int index2,int preset) {
+		altpresetids[index][index2] = preset;
+	}
+	void Set_Cost(int index,int cost) {
+		costs[index] = cost;
+	}
 #endif
 private:
 	TEAM team;
diff -uwrN sourceold/scripts/SmartGameObj.h source/scripts/SmartGameObj.h
--- sourceold/scripts/SmartGameObj.h	2016-10-31 07:17:12.405013500 +1000
+++ source/scripts/SmartGameObj.h	2018-11-11 08:30:08.525600000 +1000
@@ -77,6 +77,7 @@
 	virtual	void	Import_Creation( BitStreamClass & packet );
 	bool Is_Control_Data_Dirty(cPacket & packet);
 	bool	SCRIPTS_API Is_Obj_Visible( PhysicalGameObj *obj );
+	bool	SCRIPTS_API Is_Splash_Possible( PhysicalGameObj *obj );
 	void	Set_Enemy_Seen_Enabled( bool enabled )	{ IsEnemySeenEnabled = enabled; }
 	bool	Is_Enemy_Seen_Enabled( void )				{ return IsEnemySeenEnabled; }
 	virtual Matrix3D Get_Look_Transform(void) { return Get_Transform(); }
diff -uwrN sourceold/scripts/Vector3.h source/scripts/Vector3.h
--- sourceold/scripts/Vector3.h	2016-10-31 07:17:12.427013500 +1000
+++ source/scripts/Vector3.h	2018-11-11 08:30:08.526600000 +1000
@@ -78,6 +78,12 @@
 		Y *= oolen;
 		Z *= oolen;
 	}
+	Vector3 Normalized() const
+    {
+        Vector3 v = *this;
+        v.Normalize();
+        return v;
+    }
 	TT_INLINE float Length() const
 	{
 		return WWMath::Sqrt(Length2());
diff -uwrN sourceold/scripts/dp88_customAI.cpp source/scripts/dp88_customAI.cpp
--- sourceold/scripts/dp88_customAI.cpp	2017-05-08 20:26:23.656009000 +1000
+++ source/scripts/dp88_customAI.cpp	2018-11-11 08:30:08.527600000 +1000
@@ -34,7 +34,7 @@
 void dp88_customAI::Timer_Expired(GameObject *obj, int number)
 {
   if (TIMER_AI_THINK == number)
-    Commands->Start_Timer(obj, this, 1.0, TIMER_AI_THINK);
+    Commands->Start_Timer(obj, this, 0.10f, TIMER_AI_THINK);
 }
 
 // -------------------------------------------------------------------------------------------------
@@ -107,10 +107,10 @@
   Commands->Enable_Hibernation(obj, false);
   Commands->Innate_Enable(obj);
   Commands->Enable_Enemy_Seen(obj, true);
-  Commands->Enable_Vehicle_Transitions(obj, false);
+ // Commands->Enable_Vehicle_Transitions(obj, false);
 
   // Start timer which runs for the lifetime of this object
-  Commands->Start_Timer ( obj, this, 1.0, TIMER_AI_THINK );
+  Commands->Start_Timer ( obj, this, 0.10f, TIMER_AI_THINK );
 }
 
 // -------------------------------------------------------------------------------------------------
@@ -195,7 +195,8 @@
 
   // Priority is 0 if the unit is dead or not on teams 0 or 1
   if ( ( Commands->Get_Health ( target ) + Commands->Get_Shield_Strength ( target ) ) == 0
-    || ( Commands->Get_Player_Type ( target ) != 0 && Commands->Get_Player_Type ( target ) != 1 ) )
+	  || ( Commands->Get_Player_Type ( target ) == -2) )
+    //|| ( Commands->Get_Player_Type ( target ) != 0 && Commands->Get_Player_Type ( target ) != 1 ) )
   {
     if ( debug ) fprintf ( debugFile, "Target %d is dead or unteamed, ignoring\n", Commands->Get_ID(target));
     return 0.0;
@@ -730,14 +731,30 @@
 		if ( splashInfantry && enemy->As_SoldierGameObj() )
 		{
 			if ( debug ) fprintf ( debugFile, "Using splash damage against this target\n" );
+			if(obj->As_SmartGameObj()->Is_Splash_Possible(enemy->As_PhysicalGameObj()))
+			{
 			attackLocation(obj,Commands->Get_Position(enemy),m_bTargetPrimaryFire);
 		}
 		else
+			{
+				attackLocation ( obj, enemy->As_SoldierGameObj()->Get_Bullseye_Position(), m_bTargetPrimaryFire );
+			}
+		}
+		else
 			attackTarget(obj,enemy,m_bTargetPrimaryFire);
 	}
 	else if ( debug ) fprintf ( debugFile, "Current target has a higher priority than new enemy, continuing to attack current target\n" );
 }
 
+void dp88_AI_Turret::Damaged(GameObject *obj, GameObject *damager, float amount)
+{
+	if (!damager || amount <= 0 || !checkTeam(obj,damager) || Get_Object_Type(obj)==-2 || obj->As_SmartGameObj()->Is_Enemy_Seen_Enabled()==false)
+	{
+		return;
+	}
+	Enemy_Seen(obj,damager);
+}
+
 // -------------------------------------------------------------------------------------------------
 
 void dp88_AI_Turret::Timer_Expired( GameObject *obj, int number )
@@ -765,8 +782,17 @@
 			// Otherwise we are OK to continue attacking... if this is an infantry unit
 			// and splash targetting is enabled then update targetting position
 			else if ( splashInfantry && target->As_SoldierGameObj() )
+			{
+				if(obj->As_SmartGameObj()->Is_Splash_Possible(target->As_PhysicalGameObj()))
+				{
 				attackLocation ( obj, Commands->Get_Position(target), m_bTargetPrimaryFire );
 		}
+				else
+				{
+					attackLocation ( obj, target->As_SoldierGameObj()->Get_Bullseye_Position(), m_bTargetPrimaryFire );
+				}
+			}
+		}
 	}
 
   dp88_customAI::Timer_Expired(obj, number);
diff -uwrN sourceold/scripts/dp88_customAI.h source/scripts/dp88_customAI.h
--- sourceold/scripts/dp88_customAI.h	2016-10-31 07:17:12.462013500 +1000
+++ source/scripts/dp88_customAI.h	2018-11-11 08:30:08.529600000 +1000
@@ -334,6 +334,7 @@
   // Events
   virtual void Enemy_Seen ( GameObject *obj, GameObject *enemy );
   virtual void Timer_Expired( GameObject *obj, int number );
+  virtual void Damaged(GameObject *obj, GameObject *damager, float amount);
 
   // Custom AI initialisation script overrides
   virtual void Init( GameObject *obj );
diff -uwrN sourceold/scripts/engine_obj2.cpp source/scripts/engine_obj2.cpp
--- sourceold/scripts/engine_obj2.cpp	2016-10-31 07:17:12.478013500 +1000
+++ source/scripts/engine_obj2.cpp	2018-11-11 08:30:08.530600000 +1000
@@ -586,6 +586,26 @@
 		collisionTest.CollidedPhysObj == object->Peek_Physical_Object();
 }
 
+SCRIPTS_API bool SmartGameObj::Is_Splash_Possible(PhysicalGameObj* object)
+{
+	Vector3 bullseyePosition = object->Get_Position();
+	const Matrix3D lookTransform = Get_Look_Transform();
+	const Vector3 lookPosition = lookTransform.Get_Translation();
+	
+
+	
+	CastResultStruct castResult;
+	PhysRayCollisionTestClass collisionTest(LineSegClass(bullseyePosition,lookPosition), &castResult, BULLET_COLLISION_GROUP);
+	
+	object->Peek_Physical_Object()->Inc_Ignore_Counter();
+	PhysicsSceneClass::Get_Instance()->Cast_Ray(collisionTest, false);
+	object->Peek_Physical_Object()->Dec_Ignore_Counter();
+	
+	return
+		castResult.Fraction == 1.f ||
+		collisionTest.CollidedPhysObj == Peek_Physical_Object();
+}
+
 bool SCRIPTS_API ActionClass::Is_Acting( void )
 {
 	return ( ActionCode != NULL );
diff -uwrN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2017-12-29 17:04:51.884600100 +1000
+++ source/scripts/jmgBearHunter.cpp	2018-11-11 08:30:08.532600000 +1000
@@ -7537,6 +7537,34 @@
 	*facing = node->facing;
 	return true;
 }
+bool JMG_Utility_Custom_Teleport_To_Random_Wander_Point::Get_A_Defense_Point(Vector3 *position,float *facing)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
+	if (wanderPointGroup != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(wanderPointGroup);
+	if (!node)
+	{
+		if (!retryOnFailure)
+			Console_Input("msg JMG_Utility_Custom_Teleport_To_Random_Wander_Point ERROR: No wander points could be found for that group!");
+		return false;
+	}
+	*position = node->position;
+	*facing = node->facing;
+	return true;
+}
+bool JMG_Utility_AI_Skittish_Herd_Animal::Get_A_Wander_Point(Vector3 *position,int wanderPointGroup)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
+	if (wanderPointGroup != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetNearest(*position);
+	if (!node)
+	{
+		Console_Input("msg JMG_Utility_AI_Skittish_Herd_Animal ERROR: No wander points could be found for that group!");
+		return false;
+	}
+	*position = node->position;
+	return true;
+}
 bool JMG_Utility_Zone_Teleport_To_Random_Wander_Point_Attach::Get_A_Defense_Point(Vector3 *position,float *facing)
 {
 	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
@@ -7565,11 +7593,11 @@
 bool JMG_Utility_AI_Goto_Player::GetRandomPosition(Vector3 *position)
 {
 	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1)
-		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(Get_Int_Parameter("WanderingAIGroupID"));
+	if (wanderingAiGroupId != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(wanderingAiGroupId);
 	if (!node)
 	{
-		Console_Input("msg JMG_Utility_AI_Vehicle ERROR: No wander points could be found for that group!");
+		Console_Input("msg JMG_Utility_AI_Goto_Player ERROR: No wander points could be found for that group!");
 		*position = Vector3();
 		return false;
 	}
@@ -7579,8 +7607,8 @@
 bool JMG_Utility_AI_Goto_Enemy::GetRandomPosition(Vector3 *position)
 {
 	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1)
-		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(Get_Int_Parameter("WanderingAIGroupID"));
+	if (wanderingAiGroupId != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(wanderingAiGroupId);
 	if (!node)
 	{
 		Console_Input("msg JMG_Utility_AI_Goto_Enemy ERROR: No wander points could be found for that group!");
@@ -7593,8 +7621,8 @@
 bool JMG_Utility_AI_Goto_Enemy_Not_Star::GetRandomPosition(Vector3 *position)
 {
 	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
-	if (Get_Int_Parameter("WanderingAIGroupID") != -1)
-		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(Get_Int_Parameter("WanderingAIGroupID"));
+	if (wanderingAiGroupId != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(wanderingAiGroupId);
 	if (!node)
 	{
 		Console_Input("msg JMG_Utility_AI_Goto_Enemy_Not_Star ERROR: No wander points could be found for that group!");
